<template>
    <div class="row" :class="[isSender ? 'justify-end' : ' justify-start']">
        <div
            class="bubble-image"
            :class="[isSender ? 'justify-end sender' : '']"
            @click.stop="previewMedia"
        >
            <q-img
                fit="cover"
                :src="imageUrl"
                width="250px"
                :height="`${height}px`"
                @error="onError"
            />
            <p v-if="text" class="caption">
                {{ text }}
            </p>
            <span class="time-text helvetica-neue-medium font-10 q-pr-xs">
                {{ time }}
            </span>
            <q-btn
                dense
                text
                flat
                v-if="statusIcon.name"
                @click="resendErrorMessage(statusIcon.name, message.id)"
            >
                <q-icon
                    :name="statusIcon.name"
                    :color="statusIcon.color"
                    size="15px"
                />
            </q-btn>
        </div>
    </div>
</template>

<script lang="ts">
import MessageController from '../../../src/controller/MessageController';
import { defineComponent, ref } from 'vue';
import { Message } from 'src/services/models/Message';
import generateRandomString from 'src/services/helpers/GenerateRandomString';
import { useStore } from 'src/store';

export default defineComponent({
    name: 'BubbleImage',
    props: {
        message: {
            type: Object as () => Message,
            required: true
        }
    },
    setup(props) {
        const store = useStore();

        const { isSender, height, previewMedia, time, text, statusIcon } =
            MessageController(props.message);
        const imageUrl = ref(
            props.message.thumbnail?.url ?? props.message.file?.url ?? ''
        );
        let retryCount = 0;

        const onError = () => {
            if (retryCount < 5) {
                setTimeout(() => {
                    imageUrl.value = `${
                        props.message.thumbnail?.url ??
                        props.message.file?.url ??
                        ''
                    }?i=${generateRandomString(4)}`;
                    retryCount++;
                }, 1000);
            }
        };

        const resendErrorMessage = (statusName: any, id: string) => {
            if (statusName == 'error') {
                store.dispatch('message/resendErrorMessage', id);
            }
        };

        return {
            isSender,
            height,
            previewMedia,
            imageUrl,
            onError,
            time,
            text,
            statusIcon,
            resendErrorMessage
        };
    }
});
</script>
